package explo.agent;
import java.lang.Math;
import java.util.Random;

public class EXP3 implements Combiner{
	public Random r;
	public double gamma = 0.999; // discount factor
	public double alpha = 0.00000000112, beta = 2;
	public double w[];
	public double[][] vote;
	public double[] probaChoice;
	int lastChoice;
	//public boolean votedForWinner[];
	
	
	public EXP3(){
		r = new Random();
		w = new double[nbFeatures];
		vote = new double[6][nbFeatures];
		probaChoice = new double[6];
		//votedForWinner = new boolean[nbFeatures];
		//for(int f=0; f<nbFeatures; f++) votedForWinner[f]=false;
	}
	
	public EXP3(EXP3 cp){
		r = cp.r; alpha = cp.alpha;
		w = new double[nbFeatures];
		//votedForWinner = new boolean[nbFeatures];
		vote = new double[6][nbFeatures];
		probaChoice = new double[6];
		for(int a=0; a<6; a++){
			probaChoice[a] = cp.probaChoice[a];
			for(int f=0; f<nbFeatures; f++) vote[a][f] = cp.vote[a][f];
		}
		/*for(int f=0; f<nbFeatures; f++){ 
			w[f] = cp.w[f];
			votedForWinner[f]=cp.votedForWinner[f];
		}*/
	}
	
	public int aggregate(double[][] pred, int nbActions){
		//System.out.println("entering EXP3.aggregate()...");
		
		//System.out.println("...calcul des poids de chaque action pour chaque feature...");
		for (int f=0; f<nbFeatures; f++){
			double sv = 1e-10;
			for(int a=0; a<nbActions; a++) sv += Math.pow(pred[a][f], beta);
	//		if(f==0) System.out.println("f="+f+", sv = "+sv);
			for(int a=0; a<nbActions; a++) vote[a][f] = Math.pow(pred[a][f], beta) / sv;
		}

		//System.out.println("...calcul des poids de chaque feature...");
		double sw = 0;
		for (int f=0; f<nbFeatures; f++) sw += Math.exp(alpha * w[f]);
		double[] weight = new double[nbFeatures];
		for (int f=0; f<nbFeatures; f++) weight[f] = Math.exp(alpha * w[f])/sw;
		

		// System.out.println("...calcul des poids de chaque action...");
		double[] score = new double[nbActions];
		double ss=0;
		for(int a=0; a<nbActions; a++){
			score[a]=0;
			for(int f=0; f<nbFeatures; f++) score[a] += weight[f] * vote[a][f];
			//ss += score[a];
			ss += Math.pow(score[a], 20);
			//System.out.print(" ("+a+", "+(score[a]) + ", " + (pred[a][0]+pred[a][1]+pred[a][2]+pred[a][3]+pred[a][4]) + ")\n");
		}
		
		//System.out.println("...calcul de la proba de jouer chaque action...");
		//System.out.println("ss = "+ ss + ", probas des actions : ");
		for(int a=0; a<nbActions; a++)	//probaChoice[a] = score[a]/ss;
			probaChoice[a] = Math.pow(score[a], 20)/ss;
//			System.out.print(((int)(100*probaChoice[a]))+ " ");

			
		
		// random choice of the actions
		double u = r.nextFloat();
		int toPlay = 0;
		while (u-probaChoice[toPlay]>0) u-=probaChoice[toPlay++];
		//System.out.println("choice: "+toPlay);
		//System.out.println("... leaving EXP3.aggregate()...");
	    return(toPlay);
	}	
	
	/*
	public int aggregate(double[][] pred, int nbActions){
	//	System.out.println("entering EXP3.aggregate()...");
		double sw = 0;
		for (int f=0; f<nbFeatures; f++) sw += Math.exp(alpha * w[f]);
		double[] weight = new double[nbFeatures];
		for (int f=0; f<nbFeatures; f++) weight[f] = Math.exp(alpha * w[f])/sw;
			//weight[f] = f<6?0.17:0; // pour voir "l'oracle"
			//weight[f] = 1.0; // pour voir ce que donne des poids constants
		
		
		double bestScore = -1e10;
		boolean [] isBest = {false, false,false, false,false, false};
		int nBest = 0;
		for (int a=0; a<nbActions; a++){
			double score = 0;
			for (int f=0; f<nbFeatures; f++) score += weight[f] * pred[a][f];
			if (score>=bestScore){
				isBest[a]=true;
				if (score>bestScore){
					nBest = 1;
					bestScore = score;
					for(int b=0; b<a; b++) isBest[b]=false;
				}
				else nBest++;
			}
		}
		
		int toPlay = r.nextInt(nbActions);
		if (nBest>0){ // otherwise, maybe all predictors were NAN
			int k = r.nextInt(nBest); // we choose the k th champion
			boolean notFound = true;
			for (int a=0; notFound && a<nbActions; a++)
				if (isBest[a] && (k--==0)) {toPlay = a; notFound = false;}
		
		
			for (int f=0; f<nbFeatures; f++){
				votedForWinner[f]=true;
				for (int a=0; a<nbActions; a++){
					if (pred[a][f] > pred[toPlay][f]) votedForWinner[f]=false;
				}
			}
		}
	//	System.out.println("... leaving EXP3.aggregate()...");
		lastChoice = toPlay;
	    return(toPlay);
	}*/

	public void updateWeights(int reward, int round){
/*		double nbVoters = 0;
		for(int f=0; f<nbFeatures; f++) if (votedForWinner[f]) nbVoters++;
		double delta = (reward==1?1.0:0.0) / nbVoters; //-0.01;
		for (int f=0; f<nbFeatures; f++){
			w[f] *= gamma;
			if (votedForWinner[f]) w[f]+=delta;
		}
*/		
		if (reward==1)
			for(int f=0; f<nbFeatures; f++)	w[f] += vote[lastChoice][f] / probaChoice[lastChoice];

		if (round % 1000 == 0){
			System.out.println("Weights:");
			double slw = 0.1, sw = 0;
			for (int f=0; f<nbFeatures; f++) {slw += w[f]; sw += Math.exp(alpha * w[f]);}
			for (int f=0; f<nbFeatures; f++) if (f<6 || w[f]>slw/nbFeatures+3) System.out.print(f+":"+((int)w[f])+"("+((int)(100*Math.exp(alpha * w[f])/sw))+"%) ");
		}
	}
}
