package explo.agent;
import java.lang.Math;
import java.util.Random;

public class LDAsimple{
	public int[] n = new int[2];
	public double[] sx = new double[2];
	public double[] sx2 = new double[2];
	
	public LDAsimple(){
		for (int i=0; i<2; i++){
			n[i]=0;
			sx[i]=0;
			sx2[i]=0;
		}
	}
	
	public LDAsimple(LDAsimple cp){
		for(int i=0; i<2; i++){n[i] = cp.n[i]; sx[i] = cp.sx[i]; sx2[i] = cp.sx2[i];}
	}
	
	public void addPoint(double x, int y){
		n[y]++;
		sx[y] += x;
		sx2[y] += x*x;
	}
	
	public double score(double x){
		//  renvoie log p(y=1|x)/p(y=0|x) ** pour p(y=1)=1/2 **
		if ((n[0]>0) && (n[1]>0)){
			double[] mu = new double[2];
			double[] sig2 = new double[2];
			for (int i=0; i<2; i++){
				mu[i] = sx[i] / n[i];
				sig2[i] = sx2[i]/n[i] - mu[i]*mu[i]; 
				if (sig2[i]==0) sig2[i]=1e10;
			}
			return (0.5*( (x-mu[0])*(x-mu[0])/sig2[0] - (x-mu[1])*(x-mu[1])/sig2[1] ));
		}	
	else return(0);
	}
	
	public double predict(double x){
		double el = Math.exp(Math.min(500,-score(x)));
		double p = (double)n[1]/(n[0]+n[1]);
		return (p/(1-p)/(1+el));
	}

//	just for testing : comment first line 'package explo.agent', uncomment this, and compile with javac
/*	public static void main(String[] args){
		Random r = new Random();
		LDAsimple reg = new LDAsimple();
		int n = 1000;
		for (int i=0; i<n; i++){
			double x = r.nextFloat();
			int y = (r.nextFloat() < x/2.0 ?1:0);
			reg.addPoint(x,y);
		}
		
		double x = .2;
		double yh = reg.predict(x);
		System.out.println(x + " : " + yh);

		x = .5;
		yh = reg.predict(x);
		System.out.println(x + " : " + yh);


		x = .8;
		yh = reg.predict(x);
		System.out.println(x + " : " + yh);


		double[] mu = new double[2];
		double[] sig2 = new double[2];
		for (int i=0; i<2; i++){
			mu[i] = reg.sx[i] / reg.n[i];
			sig2[i] = reg.sx2[i]/reg.n[i] - mu[i]*mu[i];
			};
		System.out.println(mu[0] + " " + mu[1]);

		}	
		*/
}
