package explo.agent;
import java.lang.Math;
import java.util.Random;

public class PredLinSimple implements SimplePredictor{
	public double n=0;
	public double sx=0;
	public double sx2=0;
	public double sy=0;
	public double sxy=0;
	
	public PredLinSimple(){}
	
	public PredLinSimple(PredLinSimple cp){
		n = cp.n; sx = cp.sx; sx2 = cp.sx2; sy = cp.sy; sxy = cp.sxy;
	}
	
	public void addPoint(double x, int y){
		n++;
		sx += x;
		sx2 += x*x;
		sy += y;
		sxy += x*y;
	}
	
	public double optimisticPredict(double x){
		if (n*sx2 > sx*sx){
//			System.out.println("n="+n+ "sx="+sx+"sy="+sy);
			double nvx = n*sx2 - sx*sx; //System.out.println(nvx/(n*n));
			double a = (n*sxy - sx*sy)/nvx;
			double b = (sy - a * sx)/n;
			// Residual stdev (using that y only contains 0s and 1s)
			double s = Math.sqrt((sy - sy/n + a*a*sx*sx/n - a*a*sx2)/n);
		//	double ucb = a*x+b+s*Math.sqrt(Math.log(n)/2.0*((x-sx/n)*(x-sx/n)/nvx + 1.0/n));
			double ucb = a*x+b+s*Math.sqrt(1.0*((x-sx/n)*(x-sx/n)/nvx + 1.0/n));
			//System.out.println("a = " + a + ", b = " + b + ", s= " +s);
			return(Math.min(1, Math.max(0, ucb)));
		}
		else return(0);
	}
	
	public double predict(double x){
		if (n*sx2 > sx*sx){
			double a = (n*sxy - sx*sy)/(n*sx2 - sx*sx);
			double b = (sy - a * sx)/n;
			return(a*x+b);
		}
		else return(0);
	}	

//	just for testing : comment first line 'package explo.agent', uncomment this, and compile with javac
/*	public static void main(String[] args){
		Random r = new Random();
		RegLinSimple rl = new RegLinSimple();
		int n = 1000;
		for (int i=0; i<n; i++){
			double x = r.nextFloat();
			double y = r.nextFloat()<(x+1)/3?1.0:0.0;
			rl.addPoint(x,y);
		}
		double x = 0;
		double yh = rl.predict(x);
		double yucb = rl.optimisticPredict(x);
		System.out.println(x + " : " + yh + ", ucb = " + yucb);
		x = 1;
		yh = rl.predict(x);
		yucb = rl.optimisticPredict(x);
		System.out.println(x + " : " + yh + ", ucb = " + yucb);	
		x = -1;
		yh = rl.predict(x);
		yucb = rl.optimisticPredict(x);
		System.out.println(x + " : " + yh + ", ucb = " + yucb);
		}	
*/
}
