// BUGGUE QUELQUE PART !
// UTILISER PredRobustLin

package explo.agent;
import java.lang.Math;
import java.util.Random;
import explo.agent.SmartSample;


public class PredRobustLinSimple implements SimplePredictor{
	public SmartSample[] S = new SmartSample[2];
	
	public PredRobustLinSimple(int M){
		S[0] = new SmartSample(M);
		S[1] = new SmartSample(M);
	}
	
	public PredRobustLinSimple(PredRobustLinSimple cp){
		S[0] = new SmartSample(cp.S[0]);
		S[1] = new SmartSample(cp.S[1]);
	}
	
	public void addPoint(double x, int y){
		//System.out.println("entering PredRobustLinSimple.addPoint()...");
		S[y].addPoint(x); // assumes that y==0 or y==1
		//System.out.println("...leaving PredRobustLinSimple.addPoint()");
	}
/* // non-robust version	
	public double predict(double x){
		double xb0 = S[0].estimateMean();
		double xb1 = S[1].estimateMean();
		double n = S[0].size+S[1].size;
		double xb = (S[0].size*xb0+S[1].size*xb1)/n;
		double vx = (xb1-xb0)*(xb1-xb0) + (S[0].size*S[0].estimateVariance() + S[1].size*S[1].estimateVariance()) / n;
		double p = (S[1].size)/n;
		double covxy = xb1 - xb * p;
		double a = covxy/vx;
		double b = p - a * xb;
		return(a*x+b);		
	}*/
	
// robust version
	public double predict(double x){
		double xb0 = S[0].getMedian();
		double xb1 = S[1].getMedian();
		double n = S[0].size+S[1].size;
		double xb = (S[0].size*xb0+S[1].size*xb1)/n;
		double p = ((double)S[1].size)/n;		
		double vx = p*(1-p)*(xb1-xb0)*(xb1-xb0) + (1-p)*S[0].estimateVarianceIQR() + p*S[1].estimateVarianceIQR();
		//double p = (S[1].size+0.24)/(n + 100);
		double covxy = (xb1 - xb) * p;
		double a = covxy/vx;
		double b = p - a * xb;
		// System.out.println("xb="+xb+", a="+a+", b="+b);
		return(a*x+b);		
	}
	
	public double optimisticPredict(double x){
		// System.out.println("entering PredRobustLinSimple.optimisticPredict()...");
		
		
		double xb0 = S[0].getMedian();
		double xb1 = S[1].getMedian();
		double n = S[0].size+S[1].size;
		double xb = (S[0].size*xb0+S[1].size*xb1)/n;
		double p = ((double)S[1].size)/n; 
		double vx = p*(1-p)*(xb1-xb0)*(xb1-xb0) + (1-p)*S[0].estimateVarianceIQR() + p*S[1].estimateVarianceIQR(); 
		//if (n%1000 == 999) System.out.println("100p="+(100*p)+", vx="+vx+ ", vx0 = "+S[0].estimateVariance());
		//double p = (S[1].size+0.24)/(n + 100);
		double covxy = (xb1 - xb) * p;
		double a = covxy/vx;
		double b = p - a * xb;
		
		// double s = Math.sqrt((p * (n-1) - a*a*vx)/n);
		double s = Math.sqrt(p*(1-p) - a*a*vx);
		//	double ucb = a*x+b+s*Math.sqrt(Math.log(n)/2.0*((x-sx/n)*(x-sx/n)/nvx + 1.0/n));
		double ucb = a*x+b+s*Math.sqrt(1.0*((x-xb)*(x-xb)/vx + 1.0)/n);		
		//System.out.println("... leavint PredRobustLinSimple.optimisticPredict()");
		return(Math.min(1, Math.max(0, ucb)));		
	}
	
}
