package explo.agent;
import java.lang.Math;
import java.util.Random;
import explo.agent.SmartSample;


public class RobustRegLin{
	public SmartSample[] S = new SmartSample[2];
	
	public RobustRegLin(int M){
		S[0] = new SmartSample(M);
		S[1] = new SmartSample(M);
	}
	
	public RobustRegLin(RobustRegLin cp){
		S[0] = new SmartSample(cp.S[0]);
		S[1] = new SmartSample(cp.S[1]);
	}
	
	public void addPoint(double x, int y){
		S[y].addPoint(x); // assumes that y==0 or y==1
	}
/* // non-robust version	
	public double predict(double x){
		double xb0 = S[0].estimateMean();
		double xb1 = S[1].estimateMean();
		double n = S[0].size+S[1].size;
		double xb = (S[0].size*xb0+S[1].size*xb1)/n;
		double vx = (xb1-xb0)*(xb1-xb0) + (S[0].size*S[0].estimateVariance() + S[1].size*S[1].estimateVariance()) / n;
		double p = (S[1].size)/n;
		double covxy = xb1 - xb * p;
		double a = covxy/vx;
		double b = p - a * xb;
		return(a*x+b);		
	}*/
	
// robust version
	public double predict(double x){
		double xb0 = S[0].getMedian();
		double xb1 = S[1].getMedian();
		double n = S[0].size+S[1].size;
		double xb = (S[0].size*xb0+S[1].size*xb1)/n;
		double vx = (xb1-xb0)*(xb1-xb0) + (S[0].size*S[0].estimateVarianceIQR() + S[1].size*S[1].estimateVarianceIQR()) / (S[0].size+S[1].size);
		//double p = (S[1].size+0.24)/(n + 100);
		double p = (S[1].size)/n;
		double covxy = xb1 - xb * p;
		double a = covxy/vx;
		double b = p - a * xb;
		// System.out.println("xb="+xb+", a="+a+", b="+b);
		return(a*x+b);
		
	}	
}